/**************************************************************************

   File:                PCA.h

   Author(s):           Robert Sim

   Created:             11 Nov 1997

   Last Revision:       $Date: 1998/07/21 14:20:29 $

   Description: A Class for performing Principle Components Decomposition

   $Revision: 2.0 $

   $Log: PCA.h,v $
   Revision 2.0  1998/07/21 14:20:29  simra
   Final Thesis submitted version.

   Revision 1.5  1998/04/14 04:29:48  robbo
   Debugging changes.

   Revision 1.4  1998/04/14 03:38:06  robbo
   Altered PCA.  These changes should either be undone, or continued.

   Revision 1.3  1998/04/04 06:11:07  robbo
   Fixed filtering. Sm and Cheeseman is a bit too enthusiastic right now-
   the covariances are too small.  Avg error rate on scene.gml (0.01,0.2)!

   Revision 1.2  1998/03/18 15:10:34  robbo
   1. Fixed matrix&vector reads.
   2. Fixed Statistic reads.
   3. Fixed the 75% bug- no need for iteration now.
   4. Added -w flag for localize matching.

   Revision 1.1.1.1  1998/02/24 02:12:11  robbo
   First fie import.


	
   Copyright (c) 1997 by Robert Sim, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef PCA_H
#  define PCA_H
#include <iostream.h>
#include <math.h>
#include <values.h>
#include "VObject.h"
#include "vector.h"
#include "matrix.h"
#include "PrincipalComponents.h"
class PCA : public VObject{
protected:
  bool test_flag;
  static double CONDITION_THRESH;
  // util variables for ROTATE
  double g;
  double h;
  double tau;
  double s;
  inline void ROTATE(matrix& a, const int i, const int j, const int k, const int l);

public:
  PCA();  // input= N rows M columns matrix;
  ~PCA();
  // P=NxM input matrix
  // NOTE, the function below modifies P!!!!!!!!
  PrincipalComponents GetSVDPrincipalComponents(matrix& P, bool norm=false);
  PrincipalComponents GetPrincipalComponents(matrix& P, bool norm=false);  // perform the PCA;
  bool SetTestFlag(bool val) {return (test_flag=val);}
};

#endif  /* PCA_H */




