/**************************************************************************

   File:                PGM.h

   Author(s):           Robert Sim

   Created:              6 Dec 1997

   Last Revision:       $Date: 1998/02/24 02:12:11 $

   Description: 

   $Revision: 1.1.1.1 $

   $Log: PGM.h,v $
   Revision 1.1.1.1  1998/02/24 02:12:11  robbo
   First fie import.


	
   Copyright (c) 1997 by Robert Sim, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef PGM_H
#  define PGM_H

#define E_VAL 2.7182818
#include <iostream.h>
#include <math.h>
#include "VObject.h"
#include "matrix.h"
#include "interestPt.h"
extern "C" {
#include "pgm.h"
}

class PGM : public VObject
{
protected:
  int rows;
  int cols;
  gray depth;
  gray ** data;
  int draw_colour; // 0 to 255 for gray. -i for inverse thresholding

public:
  int Rows() const { return rows; }
  int Cols() const { return cols; }
  int Depth() const { return depth; }
  gray& operator()(int x, int y) {return data[y][x];}
  gray operator()(int x, int y) const {return data[y][x];}
  PGM() {  cols=rows=0;     depth=0;     data=0;  draw_colour=-200;}
  PGM(int c, int r, gray d=255);
  PGM(const PGM &I);
  PGM(matrix &m);
  gray ** GetData() {return data;}
  
  PGM& operator=(const PGM &I);
  ~PGM();
  bool load(char * filename=0);
  bool save(char * filename=0) const;

  matrix* makeMatrix(const PGM &inPGM);
  matrix* makeMatrix(const PGM &inPGM, int x1, int y1, int x2, int y2);
  matrix* makeMatrix(const PGM &inPGM, const interestPt &P, int width, int height);
  matrix* makeGaussianMatrix(const PGM &inPGM, const interestPt &P, int width, int height, PRECISION sigma=0);
  int getCorners(const PGM &inPGM, const interestPt &c, int width, int height, int* a1, int* b1, int* a2, int* b2);
  void drawWindow(PGM &inPGM, int x1, int y1, int x2, int y2);
  void drawWindow(PGM &inPGM, interestPt &P, int width, int height);

  // Draw commands
  /*void SetDrawColour(int i) {draw_colour=i;} 
  void line(int x1, int y1, int x2, int y2);
  void line(const point2i& p1, const point2i& p2);
  void rectangle(int x1, int y1, int x2, int y2);
  void rectangle(const point2i& p1, const point2i& p2);
  void point(int x, int y);
  */
  //PGM flip();
};


#endif  /* PGM_H */
