/**************************************************************************

   File:                distCoords.h

   Author(s):           Deeptiman Jugessur

   Created:             22 Dec 1998

   Last Revision:       $Date$

   Description: 

   $Revision$

   $Log$

	
   Copyright (c) 1998 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef DISTCOORDS_H
#  define DISTCOORDS_H

#include <iostream.h>
#include <math.h>

class distCoords
{
private:
  int x;  // center x
  int y;  // center y
  // corners
  int x1; 
  int y1;
  int x2;
  int y2;
  double distance;

public:
  distCoords();
  distCoords(int inx, int iny, int inx1, int iny1, int inx2, int iny2, double indist);
  int getx() const {return x;}
  int gety() const {return y;}
  int getx1() const {return x1;}
  int gety1() const {return y1;}
  int getx2() const {return x2;}
  int gety2() const {return y2;}
  double getDist() const {return distance;}
  void setx(int inx) {x=inx;}
  void sety(int iny) {y=iny;}
  void setx1(int in) {x1=in;}
  void setx2(int in) {x2=in;}
  void sety1(int in) {y1=in;}
  void sety2(int in) {y2=in;}
  void setDist(double inDist) {distance=inDist;}
  distCoords& operator=(const distCoords&);
  bool operator==(const distCoords&) const;
  void print(ostream& O) const;
  
  friend ostream& operator<<(ostream& O, const distCoords& p);
};


#endif  /* DISTCOORDS_H */
