/**************************************************************************

   File:                integer_vector.h

   Author(s):           Robert Sim

   Created:             10 Dec 1997

   Last Revision:       $Date: 1998/04/07 23:40:43 $

   Description: 

   $Revision: 1.2 $

   $Log: integer_vector.h,v $
   Revision 1.2  1998/04/07 23:40:43  simra
   Changes to compile on sgi w/ CC. It works- huge speedup!

   Revision 1.1.1.1  1998/02/24 02:12:11  robbo
   First fie import.


	
   Copyright (c) 1997 by Robert Sim, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef INTEGER_VECTOR_H
#  define INTEGER_VECTOR_H
#ifdef sgi
#include "/usr/include/CC/iostream.h"
#else
#include <iostream.h>
#endif

#ifdef sgi
#include "bool.h"
#endif

class integer_vector
{
  friend class integer_matrix;
  int* v;
  int d;
  
public:
  integer_vector(); 
  integer_vector(int n); 
  integer_vector(const integer_vector&);
 ~integer_vector(); 

  integer_vector& operator=(const integer_vector&);
  int    dim()    const { return d; }
  int& operator[](int i);
  int  operator[](int) const;
  int sqr_length() const;
  int length() const;
  integer_vector norm() const { return *this/length(); }
  integer_vector& operator+=(const integer_vector&);
  integer_vector& operator-=(const integer_vector&);
  integer_vector  operator+(const integer_vector& v1) const;
  integer_vector  operator-(const integer_vector& v1) const;
  int  operator*(const integer_vector& v1) const;
  integer_vector  operator*(int r)        const;
  integer_vector  operator-() const;
  integer_vector  operator/(int)        const;
  bool     operator==(const integer_vector& w) const;
  bool     operator!=(const integer_vector& w)  const { return !(*this == w); }
  friend integer_vector operator*(int f, const integer_vector& v) { return v *f; }
  void print(ostream& O) const;
  void print() const { print(cout); }
  void read(istream& I);
  void read() { read(cin); }
  friend ostream& operator<<(ostream& O, const integer_vector& v);
  friend istream& operator>>(istream& I, integer_vector& v);
};

#endif  /* INTEGER_VECTOR_H */
