
#include "interestPoint.h"

interestPoint::interestPoint()
  :
  interestPt(-1,-1,6)
{
  density=-1;
  orientation=-1;
  var_density=-1;
  var_orientation=-1;
  str_orientation=-1;
  confidence=-1;
}
interestPoint::interestPoint(int inX, int inY)
  :
  interestPt(inX,inY,6)
{
  density=-1;
  orientation=-1;
  var_density=-1;
  var_orientation=-1;
  str_orientation=-1;
  confidence=-1;

  float sign[6]={density,orientation,var_density,var_orientation,str_orientation,confidence};
  setSignature(6,sign);
}

interestPoint::interestPoint(int inX, int inY, float inDen, float inOrt)
  :
  interestPt(inX,inY,6)
{
  density=inDen;
  orientation=inOrt;
  var_density=-1;
  var_orientation=-1;
  str_orientation=-1;
  confidence=-1;

  float sign[6]={density,orientation,var_density,var_orientation,str_orientation,confidence};
  setSignature(6,sign);
}

interestPoint::interestPoint(int inX, int inY, float inDen, float inOrt, float denVar, float ortVar)
  :
  interestPt(inX,inY,6)
{
  density=inDen;
  orientation=inOrt;
  var_density=denVar;
  var_orientation=ortVar;
  str_orientation=-1;
  confidence=-1;

  float sign[6]={density,orientation,var_density,var_orientation,str_orientation,confidence};
  setSignature(6,sign);
}

interestPoint::interestPoint(int inX, int inY, float inDen, float inOrt, float denVar, float ortVar, float ortStr)
  :
  interestPt(inX,inY,6)
{
  density=inDen;
  orientation=inOrt;
  var_density=denVar;
  var_orientation=ortVar;
  str_orientation=ortStr;
  confidence=-1;

  float sign[6]={density,orientation,var_density,var_orientation,str_orientation,confidence};
  setSignature(6,sign);
}

interestPoint &
interestPoint::operator=(const interestPoint& p)
{
  setx(p.getx());
  sety(p.gety());
  setn(p.getn());
  setSignature(p.getn(),p.getSignature());
  density=p.getDensity();
  orientation=p.getOrientation();
  var_density=p.getVarDensity();
  var_orientation=p.getVarOrientation();
  str_orientation=p.getStrOrientation();
  confidence=p.getConfidence();

  return *this;
}


interestPoint &
interestPoint::operator=(const interestPt& p)
{
  if (p.getn() < 6)
  {
    fprintf(stderr,"Incompatibility between interestPt base class and interestPoint sub class\n");
    exit(-1);
  }

  setx(p.getx());
  sety(p.gety());
  setn(p.getn());
  setSignature(p.getn(),p.getSignature());
  density=(p.getSignature())[0];
  orientation=(p.getSignature())[1];
  var_density=(p.getSignature())[2];
  var_orientation=(p.getSignature())[3];
  str_orientation=(p.getSignature())[4];
  confidence=(p.getSignature())[5];

  return *this;
}

void
interestPoint::printDetail()
{
  cout << "[" << getx() << ", " << gety() << ", " 
       << getDensity() << ", " << getOrientation() << ", " 
       << getVarDensity() << ", " << getVarOrientation() << ", "
       << getStrOrientation() << ", " << getConfidence() << "]";
}
  


