/**************************************************************************

   File:                interestPoint.h

   Author(s):           Deeptiman Jugessur

   Created:             11 Aug 1998

   Last Revision:       $Date$

   Description: 

   $Revision$

   $Log$

	
   Copyright (c) 1998 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef INTERESTPOINT_H
#  define INTERESTPOINT_H

#include <iostream.h>
#include <stdio.h>
#include "interestPt.h"

class interestPoint : public interestPt
{
private:
  float density;
  float var_density;
  float orientation;
  float var_orientation;
  float str_orientation;
  float confidence;

public:
  interestPoint();
  interestPoint(int inX, int inY);
  interestPoint(int inX, int inY, float inDen, float inOrt);
  interestPoint(int inX, int inY, float inDen, float inOrt, float denVar, float ortVar);
  interestPoint(int inX, int inY, float inDen, float inOrt, float denVar, float ortVar, float ortStr);
  interestPoint& operator=(const interestPoint&);
  interestPoint& operator=(const interestPt&);
  float getDensity() const {return density;}
  float getOrientation() const {return orientation;}
  float getVarDensity() const {return var_density;}
  float getVarOrientation() const {return var_orientation;}
  float getStrOrientation() const {return str_orientation;}
  float getConfidence() const {return confidence;}
  void setDensity(float val) {density=val;}
  void setOrientation(float val) {orientation=val;}
  void setVarDensity(float val) {var_density=val;}
  void setVarOrientation(float val) {var_orientation=val;}
  void setStrOrientation(float val) {str_orientation=val;}
  void setConfidence(float val) {confidence = val;}
  void printDetail();
  
};


#endif  /* INTERESTPOINT_H */

