/**************************************************************************

   File:                interestPt.h

   Author(s):           Deeptiman Jugessur

   Created:             11 Aug 1998

   Last Revision:       $Date$

   Description: 

   $Revision$

   $Log$

	
   Copyright (c) 1998 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef INTERESTPT_H
#  define INTERESTPT_H

#include <iostream.h>

class interestPt
{
private:
  int x;
  int y;
  int n; // number of signatures
  float *signature;
  float compare; // used to compare one interest point to another (eg by using L2 norms)

public:
  interestPt();
  interestPt(int inX, int inY);
  interestPt(int inX, int inY, int inN);
  interestPt(int inX, int inY, int inN, float *sigs);
  interestPt(const interestPt&);
  ~interestPt();

  interestPt& operator=(const interestPt&);

  int getx() const {return x;}
  int gety() const {return y;}
  int getn() const {return n;}
  float getCompare() const {return compare;}
  float *getSignature() const {return signature;}
  void setx(int val) {x=val;}
  void sety(int val) {y=val;}
  void setn(int val) {n=val;}
  void setCompare(float val) {compare=val;}
  void setSignature(int inN, float *sigs);

  float keyAt(int l);
  float euclideanDist(interestPt &p);

  void print(ostream& O) const;
  void read(istream& I);
  void read() {read(cin);}
  void read(char *buf);


  friend ostream& operator<<(ostream& O, const interestPt& p);
  friend istream& operator>>(istream& I, interestPt& pt);
};


#endif  /* interestPt_H */

