/**************************************************************************

   File:                IOdata.h

   Author(s):           Deeptiman Jugessur

   Created:             31 Oct 1998

   Last Revision:       $Date$

   Description: 

   $Revision$

   $Log$

	
   Copyright (c) 1998 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 **************************************************************************/

#ifndef IODATA_H
#  define IODATA_H

#include <iostream.h>
#include <fstream.h>
#include "matrix.h"
#include "interestPt.h"


class ioData
{
private:
  int numDatabaseRows;
  int numDatabaseCols;
  int numArrRows;
  int numArrCols;
  int allocated;
  matrix *database;         // The PCA database
  interestPt **array;   // interestPoints for all the images in the database

public:
  ioData(int dbR, int dbC, int arrR, int arrC, fstream& dbstream, fstream& ipstream); 
  ioData(matrix *dataB, interestPt **arr, int arrR, int arrC);
  ~ioData();
  void dbRead(istream& I);
  void dbWrite(ostream& O) const;
  void arrRead(istream& I);
  void arrWrite(ostream& O) const;
  matrix getDatabase() {return *database;}
  interestPt getInterestpoint(int i, int j) {return array[i][j];}
  void clearIoData();
};

#endif  /* IODATA_H */



