/************************************************************************

   File:		testfft.c

   Author(s):		Deeptiman Jugessur

   Created:		18 Jul 1999

   Last Revision:	$Date$

   Description:	

   $Revision$

   $Log$

	
   Copyright (c) 1999 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 ***********************************************************************/

#include <stdio.h>
#include "PPM.h"
#include "PGM.h"
#include "matrix.h"
#include "fft.h"

// changes names to ext instead of .pgm or .ppm.  Assumes everything has already been
// allocated
void 
convertName(char *in, char *out, char *ext)
{
  char *delimiter;

  strcpy(out, in);
  delimiter = strrchr(out,'.');
  *delimiter = '\0';
  strcat(out,ext);
}


int main(int argc, char **argv)
{
  /*
  double **t;

  t = new double*[5];
  for (int i=0; i<5; i++)
    t[i] = new double[5];

  int count = 1;
  for (int i=0; i<5; i++)
    for (int j=0; j<5; j++)
      t[i][j] = (int)(10*(((double)rand())/RAND_MAX));

  matrix small(5,5,t);

  cout << small << "\n";

  matrix cropped;
  cropped = small.crop(2,2,7,7);

  cout << cropped << "\n";
  exit(1);
  */


  char file[255] = "/home/tsunami/deepu/pcaproject/deeppca/src/sharedSrc/";
  char in1[255];
  char in2[255];
  char out1[255];
  char out2[255];
  char copy[255];

  strcpy(in1,file);
  strcpy(in2,file);
  strcpy(out1,file);
  strcpy(out2,file);

  strcat(in1,argv[1]);
  strcpy(copy,in1);
  convertName(copy,out1,".phase");
  strcat(in2,argv[2]);
  strcpy(copy,in2);
  convertName(copy,out2,".phase");


  cout << in1 << "\n";
  cout << in2 << "\n";
  cout << out1 << "\n";
  cout << out2 << "\n";

  PGM i1;
  if (!i1.load(in1))
    {
      fprintf(stderr,"Problems loading %s\n",in1);
      exit(1);
    }

  PGM i2;
  if (!i2.load(in2))
    {
      fprintf(stderr,"Problems loading %s\n",in2);
      exit(1);
    }

  matrix *m1;
  matrix *m2;
  matrix *p1=new matrix();
  matrix *p2=new matrix();
  matrix *g1=new matrix();
  matrix *g2=new matrix();

  fft *thefft1;
  fft *thefft2;

  m1 = i1.makeMatrix(i1);
  m2 = i2.makeMatrix(i2);
  *p1 = m1->makePolarMatrix(*m1,m1->dim1(),m1->dim2());
  *p2 = m2->makePolarMatrix(*m2,m2->dim1(),m2->dim2());

  *g1 = p1->makeGaussianMatrix(*p1);
  *g2 = p2->makeGaussianMatrix(*p2);
  thefft1 = new fft(*g1);
  thefft2 = new fft(*g2);

  thefft1->computeAmplitudeAndPhase();
  thefft2->computeAmplitudeAndPhase();

  matrix *phase1 = thefft1->getPhase();
  matrix *phase2 = thefft2->getPhase();

  PGM phase0(*phase1);
  phase0.save(out1);

  PGM phase45(*phase2);
  phase45.save(out2);

  //  double angle = thefft1->recoverPhase(*phase1,*phase2);
  double angle = fft::recoverPhase(*p1,*p2);
  cout << "Angle = " << angle*180/3.1415927 << "\n";
}


  /* Test matrix dilation
  double **t;

  t = new double*[3];
  for (int i=0; i<3; i++)
    t[i] = new double[3];

  int count = 1;
  for (int i=0; i<3; i++)
    for (int j=0; j<3; j++)
      //      t[i][j] = ((double)rand())/RAND_MAX;
      t[i][j] = 10;

  matrix small(3,3,t);

  cout << small << "\n";

  matrix big;
  big = small.makeBiggerMatrix(small,5,5);

  cout << big << "\n";
  exit(1);
  */





  /*
  double **t;

  t = new double*[8];
  for (int i=0; i<8; i++)
    t[i] = new double[8];

  int count = 1;
  for (int i=0; i<8; i++)
    for (int j=0; j<8; j++)
      t[i][j] = ((double)rand())/RAND_MAX;

  matrix m(8,8,t);

  cout << m << "\n";

  matrix polar = m.makePolarMatrix(m,8,8);

  cout << polar << "\n";

  fft thefft(m);
  */
  
  /*
  PGM pgmimage;
  if (!pgmimage.load("/home/tsunami/deepu/pcaproject/deeppca/src/symmetryVersion/images/elipse.pgm"))
    {
      fprintf(stderr,"Problems loading\n");
      exit(1);
    }

  matrix *m = pgmimage.makeMatrix(pgmimage);
  matrix *mcrop = pgmimage.makeMatrix(pgmimage,30,15,90,115);

  PGM newimage(*m);
  PGM newcrop(*mcrop);

  newimage.save("newimage.pgm");
  newcrop.save("newcrop.pgm");
  */




