/************************************************************************

   File:		testfft.c

   Author(s):		Deeptiman Jugessur

   Created:		18 Jul 1999

   Last Revision:	$Date$

   Description:	

   $Revision$

   $Log$

	
   Copyright (c) 1999 by Deeptiman Jugessur, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 ***********************************************************************/

#include <stdio.h>
#include "PPM.h"
#include "PGM.h"
#include "matrix.h"
#include "fft.h"


// changes names to ext instead of .pgm or .ppm.  Assumes everything has already been
// allocated
void 
convertName(char *in, char *out, char *ext)
{
  char *delimiter;

  strcpy(out, in);
  delimiter = strrchr(out,'.');
  *delimiter = '\0';
  strcat(out,ext);
}

void main(int argc, char **argv)
{
  
  char file[255] = "/home/tsunami/deepu/pcaproject/deeppca/src/sharedSrc/";
  char ppmFile[255];
  char pgmFile[255];
  char polarFile[255];
  char ampFile[255];
  char phaseFile[255];
  char gaussFile[255];
  char copy[255];

  int flag=0;


  strcpy(ppmFile,file);
  strcpy(pgmFile,file);
  strcpy(polarFile,file);
  strcpy(ampFile,file);
  strcpy(phaseFile,file);
  strcpy(gaussFile,file);
  
  strcat(ppmFile,argv[1]);
  strcpy(copy,ppmFile);

  flag=atoi(argv[2]);
  
  convertName(copy, pgmFile, ".pgm");
  strcpy(copy,ppmFile);
  convertName(copy, polarFile, ".polar");
  strcpy(copy,ppmFile);
  convertName(copy, ampFile, ".amp");
  strcpy(copy,ppmFile);
  convertName(copy, phaseFile, ".phase");
  strcpy(copy,ppmFile);
  convertName(copy, gaussFile, ".gauss");
  strcpy(copy,gaussFile);

  

  // printf("%s\n%s\n%s\n%s\n%s\n",ppmFile,pgmFile,polarFile,ampFile,phaseFile);
    
  PPM image;
  if (!image.load(ppmFile))
    {
      fprintf(stderr,"Problems loading\n");
      exit(1);
    }

  matrix *r;
  matrix *g;
  matrix *b;
  matrix *polar = new matrix();
  matrix *gauss = new matrix();
  fft *thefft;

  r = image.makeMatrix(image,'r');
  g = image.makeMatrix(image,'g');
  b = image.makeMatrix(image,'b');

  matrix m = (*r)*0.299 + (*g)*0.587 + (*b)*0.114;

  PGM face(m);
  cout << "First PGM\n";
  face.save(pgmFile);

  /*
  *gauss = m.makeGaussianMatrix(m);      
  PGM gaussIm(*gauss);
  cout << "Second PGM\n";
  gaussIm.save(gaussFile);
  exit(1);
  */

  if (flag) // make polar then multiply by a gaussian
    {
      *polar = m.makePolarMatrix(m,m.dim1(),m.dim2());
      PGM polarIm(*polar);
      cout << "Second PGM\n";
      polarIm.save(polarFile);
      *gauss = (*polar).makeGaussianMatrix(*polar);
      PGM gaussIm(*gauss);
      cout << "Third PGM\n";
      gaussIm.save(gaussFile);
      thefft = new fft(*gauss);
    }
  else
    {
      *gauss = m.makeGaussianMatrix(m);      
      PGM gaussIm(*gauss);
      cout << "Second PGM\n";
      gaussIm.save(gaussFile);
      *polar = gauss->makePolarMatrix(*gauss,gauss->dim1(),gauss->dim2());
      PGM polarIm(*polar);
      cout << "Third PGM\n";
      polarIm.save(polarFile);            
      thefft = new fft(*polar);
    }

  thefft->computeAmplitudeAndPhase();
  cout << "Fourth PGM\n";
  PGM phase(*(thefft->getPhase()));
  /*
  for (int i=0;i<mamplitude->dim1();i++) {
    (*mamplitude)[i] = (*mamplitude)[i].norm();
  }
  */


  /*
  for (int i=29; i<35; i++)
    for (int j=29; j<35; j++)
      (*mamplitude)(i,j) = 0;
  */

  PGM amplitude(*(thefft->getAmplitude()));
  phase.save(phaseFile);
  cout << "Fifth PGM\n";
  amplitude.save(ampFile);

  
  
}


  /* Test matrix dilation
  double **t;

  t = new double*[3];
  for (int i=0; i<3; i++)
    t[i] = new double[3];

  int count = 1;
  for (int i=0; i<3; i++)
    for (int j=0; j<3; j++)
      //      t[i][j] = ((double)rand())/RAND_MAX;
      t[i][j] = 10;

  matrix small(3,3,t);

  cout << small << "\n";

  matrix big;
  big = small.makeBiggerMatrix(small,5,5);

  cout << big << "\n";
  exit(1);
  */





  /*
  double **t;

  t = new double*[8];
  for (int i=0; i<8; i++)
    t[i] = new double[8];

  int count = 1;
  for (int i=0; i<8; i++)
    for (int j=0; j<8; j++)
      t[i][j] = ((double)rand())/RAND_MAX;

  matrix m(8,8,t);

  cout << m << "\n";

  matrix polar = m.makePolarMatrix(m,8,8);

  cout << polar << "\n";

  fft thefft(m);
  */
  
  /*
  PGM pgmimage;
  if (!pgmimage.load("/home/tsunami/deepu/pcaproject/deeppca/src/symmetryVersion/images/elipse.pgm"))
    {
      fprintf(stderr,"Problems loading\n");
      exit(1);
    }

  matrix *m = pgmimage.makeMatrix(pgmimage);
  matrix *mcrop = pgmimage.makeMatrix(pgmimage,30,15,90,115);

  PGM newimage(*m);
  PGM newcrop(*mcrop);

  newimage.save("newimage.pgm");
  newcrop.save("newcrop.pgm");
  */




