/************************************************************************

   File:		utilityclasses.cpp

   Author(s):		Robert Sim

   Created:		14 Dec 1997

   Last Revision:	$Date: 1998/07/21 14:21:58 $

   Description:	

   $Revision: 2.0 $

   $Log: utilityclasses.cpp,v $
   Revision 2.0  1998/07/21 14:21:58  simra
   Final Thesis submitted version.

   Revision 1.5  1998/04/07 23:40:47  simra
   Changes to compile on sgi w/ CC. It works- huge speedup!

   Revision 1.4  1998/04/02 22:43:30  simra
   Abstracted LocalizationResults away and rewrote the plotter to get a better
   look at what's going on.  We need to separate basic constellation data from
   hard-core data.  Also point3f's etc should be aliased vectors to make life
   nice.

   Revision 1.3  1998/03/16 01:56:32  robbo
   1. removed area division from landmark.cpp--- scaling by area affects
      threshold selection.
   2. changed default localization method to PCAmethod.

   Revision 1.2  1998/03/15 18:39:02  robbo
   1. Rewrote purging and set it up to be on by default in eigentrack.
   2. Implemented Sm and Cheesman-like uncertainty measures for lms.
      This needs to be implemented into eigentrack or RecomputeStats for
      precomputation.  It takes some time but I think it should be useful
      in the end.
   3. uncertainty implementation required some point3f vs vector
      reimplementation.  I'm not entirely satisfied w/ the results. Too
      much is tied to the LocalizationWindow way of looking at the data,
      and so I need to rewrite all the linf, votedat objects.  A lot of
      the old localization methods are obsolete now.

   Revision 1.1.1.1  1998/02/24 02:12:11  robbo
   First fie import.


	
   Copyright (c) 1997 by Robert Sim, Centre for Intelligent Machines,
   McGill University, Montreal, QC.  Please see the copyright notice
   included in this distribution for full details.

 ***********************************************************************/

#define UTILITYCLASSES_CPP
#include "utilityclasses.h"
#include <ctype.h>

ostream& operator<<(ostream& O, const point3f& p) {
  O<<p.x<<" "<<p.y<<" "<<p.z; 
  return O;
}

istream& operator>>(istream& I, point3f& p) {
  I >> p.x >> p.y >> p.z;
  return I;
}

ostream& operator<<(ostream& O, point2i p) {
  O<<p.x<<" "<<p.y; 
  return O;
}

ostream& operator<<(ostream& O, point2f p) {
  O<<p.x<<" "<<p.y; 
  return O;
}


istream& operator>>(istream& I, point2i& p) {
  I >> p.x >> p.y;
  return I;
}

istream& operator>>(istream& I, point2f& p) {
  I >> p.x >> p.y;
  return I;
}


int
GMLObject::nextGMLToken(istream &I, char * tok, int len) {
  int c;
  do {
    c=I.get();
    if (c=='#') do c=I.get(); while (c!='\n');
    else if (c==')') {
      return 0;
    }
  } while (c!='(');
  I.get(tok,len,' ');
  return 1;
}
  
int
GMLObject::closeGMLField(istream &I) {
  int c;
  do {
    c=I.get();
    if (c=='#') do c=I.get(); while (c!='\n');
    else if (c=='(') {
      cerr<<"Trouble in closeGMLField"<<endl;
      return 0;
    }
  } while (c!=')');
  return 1;
}
