/*******************************************************************************
+
+  My vector.h  Sort of (but not really) LEDA 3.5.1 compatible
+
+  vector.h
+
+ 
*******************************************************************************/
#ifndef VECTOR_H
#define VECTOR_H
#ifdef sgi
#include "/usr/include/CC/iostream.h"
#else
#include <iostream.h>
#endif

#include <assert.h>
//------------------------------------------------------------------------------
//  vectors
//------------------------------------------------------------------------------
#ifdef sgi
#include "bool.h"
#endif

#if defined(DOUBLE)
#define PRECISION double
#else
#define PRECISION float
#endif

class vector
{
  friend class matrix;
  PRECISION* v;
  unsigned int d;
  
public:
  vector(); 
  vector(unsigned int n); 
  vector(unsigned int n, PRECISION *values);
  vector(const vector&);
  vector(PRECISION x, PRECISION y);
  ~vector(); 


  vector *assignDifference(vector const *,vector const *);
  void copyVector(vector *v1);
  vector& operator=(const vector&);
  int    dim()    const { return d; }
  PRECISION& operator[](unsigned int i);
  PRECISION  operator[](unsigned int) const;
  PRECISION sqr_length() const;
  PRECISION length() const;
  vector norm() const;
  vector& operator+=(const vector&);
  vector& operator-=(const vector&);
  vector  operator+(const vector& v1) const;
  vector  operator-(const vector& v1) const;
  PRECISION  operator*(const vector& v1) const;
  vector  operator*(PRECISION r)        const;
  vector  operator-() const;
  vector  operator/(PRECISION)        const;
  bool     operator==(const vector& w) const;
  bool     operator!=(const vector& w)  const { return !(*this == w); }
  friend vector operator*(PRECISION f, const vector& v) { return v *f; }
  void print(ostream& O) const;
  void printBinary(ostream& O, int flag=0) const; // flag values:0 for PRECISIONs, 1 for ints
  void print() const { print(cout); }
  void read(istream& I);
  void readBinary(istream& I, int flag=0);  // flag values:0 for PRECISIONs, 1 for ints
  void read() { read(cin); }
  friend ostream& operator<<(ostream& O, const vector& v);
  friend istream& operator>>(istream& I, vector& v);
};

#endif













