function a = arg(x, y, magnit)
% ARG		Return the argument of the vector whose x-coordinates are in `x'
%		and y-coordinates in `y'.  If `magnit' is given, threshold the
%		argument according to `magnit'.
%		
%		A = arg(X, Y, MAGNIT)
%		X - X-coordinates.
%		Y - Y-coordinates.
%		MAGNIT - Magnitude, according to which thresholding is 
%				performed.

%
% Written by Ariel Tankus, 19.9.96.
%

a = atan2(y, x);

if nargin > 2
    % a=0, if magnitude is 0
    a = a .* (magnit ~= 0);
end

