function d = dgauss(t, sigma, mu)
% GAUSSIAN	Return the value of the derivative of the gaussian with mean 
%		`mu' and standard deviation `sigma' at point(s) `t'.
%		
%		G = GAUSSIAN(T, SIGMA, MU)
%		T     - scalar/vector/matrix.  At each element, calculates the
%		           Gaussian.
%		SIGMA - Standard deviation of the Gaussian.
%		MU    - mean of the Gaussian.
%		
%		G     - value of the Gaussian at point(s) T.
%		

%
% Written by Ariel Tankus, 19.9.96.
%

if nargin < 3, mu = 0; end
if nargin < 2, sigma = 1; end

d = -t ./ (sqrt(2*pi) * sigma^3) .* exp(-(t-mu) .^ 2 / (2*sigma^2));
%d = -2*t ./ (sigma^2) .* gauss(t,sigma,mu);