// Author: Ariel Tankus.
// Created: Sept. 1996.
// Last modified: 26.3.1999.

#include <string.h>
#include "mex.h"
#include "general.h"

/*
  Is `mat' a regular matrix, i.e., its display type is numeric, it is not
  complex, it is full and double.
  */
int isNormal(const mxArray *mat)
{
    return (mxIsNumeric(mat) && !mxIsComplex(mat) &&
	    !mxIsSparse(mat)  && mxIsDouble(mat));
}

/*
Fimage MatrixToFimage(mxArray *m)
{
    int rows = mxGetM(m);
    int cols = mxGetN(m);

    double *array = mxGetPr(m);
    float *fArray = new float[rows * cols];

    register int i, j;
    for (i = 0; i < cols; i++)
	for (j = 0; j < rows; j++)
	    fArray[i+cols*j] = float(array[j+rows*i]);

    return new myImage<float>(cols, rows, fArray);
}

mxArray *FimageToMatrix(Fimage im)
{
    int width = im->width();
    int height = im->height();
    mxArray *mat = mxCreateDoubleMatrix(height, width, mxREAL);

    double *array = new double[width*height];
    float *fArray = im->extract();

    register int i, j;
    for (i = 0; i < height; i++)
	for (j = 0; j < width; j++)
	    array[i+height*j] = double(fArray[j+width*i]);

    mxSetPr(mat, array);
}
*/

// return a float array which contains 0.0 in every cell.
double *clear(int size)
{
    return (double *)memset(new double[size], 0, size * sizeof(double));
}
