// Author: Ariel Tankus.
// Created: Sept. 1996.
// Last modified: 26.3.1999.

#include "mex.h"
#include "matrix.h"
#include "mymatrix.h"
#include "matrix_ifc.h"

mymatrix<double>& MatrixTomatrix(const mxArray *mat)
{
    return *new mymatrix<double>(mxGetM(mat), mxGetN(mat), mxGetPr(mat));
}

mxArray *matrixToMatrix(mymatrix<double>& mat)
{
    mxArray *m = mxCreateDoubleMatrix(mat.rows(), mat.columns(), mxREAL);
    
    mxSetPr(m, (double *)mat);
    return m;
}

mymatrix<double> *createOutput(int nlhs, mxArray *plhs[], int lhs_no,
			       int rows, int cols)
{
    if (lhs_no >= nlhs)
	// argument not present
	return NULL;

    plhs[lhs_no] = mxCreateDoubleMatrix(rows, cols, mxREAL);
    return new mymatrix<double>(rows, cols, mxGetPr(plhs[lhs_no]), MOVE);
}

int MatrixToInt(const mxArray *mat)
{
    int mat_m = mxGetM(mat);
    int mat_n = mxGetN(mat);

    if ((mat_m != 1) || (mat_n != 1))
	mexErrMsgTxt("Argument must be an integer.");

    return int(mxGetScalar(mat));
}
