% operate_radial    Demonstrate the usage of the radial symmetry operator.
%

% Author: Ariel Tankus.  Modified Deeptiman Jugessur
% Created: 26.3.1999.

im = readpgm('icetea.pgm');   
[a, mag, dx, dy] = autoarg(im, 5, 5);
lmag = log1p(mag);
[radi, symag, symori] = radial(5, 5, 0, dx, dy, mag, lmag, a);


[I,J] = size(radi);

bigmat = zeros(I*J,6);

row=1;
for i=1:I
    for j=1:J
       if (radi(i,j) > 1)         
         bigmat(row,1) = i;
         bigmat(row,2) = j;
         bigmat(row,3) = radi(i,j);
         bigmat(row,4) = symag(i,j);
         bigmat(row,5) = symori(i,j); 
         bigmat(row,6) = im(i,j);
         row = row+1;
       end
    end
end

bigmat(row:I*J,:) = [];

allsorted = sortrows(bigmat,3);
flippedallsorted = flipdim(allsorted,1);
data = fopen('newdata','w');
fprintf(data,'(%d,%d)\t[%10.10f,%10.10f,%10.10f,%10.10f]\n',flippedallsorted');
fclose(data);
