% operate_radial    Demonstrate the usage of the radial symmetry operator.
%

% Author: Ariel Tankus.  Modified Deeptiman Jugessur
% Created: 26.3.1999.

im = readpgm('bluedogTest.pgm');   
[a, mag, dx, dy] = autoarg(im, 5, 5);
lmag = log1p(mag);
[radi, symag, symori] = radial(30, 30, 0, dx, dy, mag, lmag, a);
[I,J] = size(radi);
bigmat = zeros(I*J,5);
row=1;
for i=1:I
  for j=1:J
    if (radi(i,j) > 1)
      bigmat(row,1) = j;
      bigmat(row,2) = i;
      bigmat(row,3) = radi(i,j);
      bigmat(row,4) = symag(i,j);
      bigmat(row,5) = symori(i,j);
      row = row+1;
    end;
  end;
end;
bigmat(row:I*J,:) = [];
bigmatsorted = sortrows(bigmat,3);
flippedallsorted = flipdim(bigmatsorted,1);
if (row > 5000)
     flippedallsorted(5000:row-1,:) = [];
end;
data = fopen('bluedogTest.dat','w');
fprintf(data,'#3\t(%d,%d)\t[%10.10f %10.10f %10.10f]\n',flippedallsorted');
fclose(data);


