% operate_radial    Demonstrate the usage of the radial symmetry operator.
%

% Author: Ariel Tankus.  Modified Deeptiman Jugessur
% Created: 26.3.1999.

im = readpgm('tomato.pgm');   
[a, mag, dx, dy] = autoarg(im, 5, 5);
lmag = log1p(mag);
[radi, symag, symori] = radial(5, 5, 0, dx, dy, mag, lmag, a);

imagesc(radi);
%imagesc(symag);
%imagesc(symori);

[i,j,spradi] = find(radi);
[k,l,spsymag] = find(symag);
[m,n,spsymori] = find(symori);

% takes care of uneven sizes by chopping of extra rows
if ((length(i) == length(k)) & (length(k) == length(m)))
   combine = [j,i,spradi,spsymag,spsymori];
else
%   fprintf('i=%d, j=%d, k=%d, l=%d, m=%d, n=%d\n',length(i),length(j),length(k),length(l),length(m),length(n));
   minDim = min([length(i), length(k), length(m)]);
   if (length(i) > minDim)
     i(minDim+1:length(i),:) = [];
     j(minDim+1:length(j),:) = [];
     spradi(minDim+1:length(spradi),:) = [];
   end
   if (length(k) > minDim)
     k(minDim+1:length(k),:) = [];
     l(minDim+1:length(l),:) = [];
     spsymag(minDim+1:length(spsymag),:) = [];
   end
   if (length(m) > minDim)
     m(minDim+1:length(m),:) = [];
     n(minDim+1:length(n),:) = [];
     spsymori(minDim+1:length(spsymori),:) = [];
   end
%  fprintf('i=%d, j=%d, k=%d, l=%d, m=%d, n=%d\n',length(i),length(j),length(k),length(l),length(m),length(n));
   combine = [j,i,spradi,spsymag,spsymori];
end


allsorted = sortrows(combine,3);
flippedallsorted = flipdim(allsorted,1);
data = fopen('data','w');
fprintf(data,'(%d,%d)\t[%10.10f,%10.10f,%10.10f]\n',flippedallsorted');
fclose(data);

colormap(gray)











