% symmetry    Computes the symmetry map of an image (both magnitude and
%             argument).  Capable of computing full/dark/bright symmetries.
%
%             [symMagnit, symOrient] = symmetry(rx, ry, kind, dxIm, ...
%                          dyIm, gradIm, logGradIm, argIm)
%
%             Input:
%             ------
%             rx, ry      - radii for the neighborhood where symmetry is
%                           considered. 
%             kind        - the kind of symmetry searched:
%                                  0 - full, 1 - dark, or 2 - bright.
%             dxIm, dyIm  - derivatives of the image in x, y directions
%                           respectively.
%             gradIm, logGradIm - magnitude of gradient (and it's log) of the
%                           images.
%             argIm       - argument of the gradient to the image.
%
%             Output:
%             -------
%             symMagnit   - magnitude of the symmetry map. (opt.)
%             symOrient   - orientation of the symmetry map. (opt.)
%
%             See also: radial, autoarg, xderiv, yderiv, grad.

% Author: Ariel Tankus.
% Created: 26.3.1999.
